﻿using System;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace Sat2Ip.Library
{
    internal class Utils
    {
        public static String GetLocalHostName()
        {
            return Dns.GetHostName();
        }
        public static String GetIpAddress(String value)
        {
            string str = null;
            var hostentry = Dns.GetHostEntry(value);
            foreach (var ip in hostentry.AddressList.Where(ip => ip.AddressFamily == AddressFamily.InterNetwork))
            {
                str = ip.ToString();
            }
            return str;
        }

        public static int GenerateRandomNumber(int minValue, int maxValue)
        {
            int retval = 0;
            var random = new Random();
            retval = random.Next(minValue, maxValue);
            return retval;
        }

        #region Converters

        public static string BytesToString(byte[] revBuffer, int revBytesCount)
        {
            var s = Encoding.Default.GetString(revBuffer, 0, revBytesCount);
            return s;
        }

        public static byte[] StringToBytes(string request)
        {
            var bytes = Encoding.Default.GetBytes(request);
            return bytes;
        }

        public static long BytesToLong(byte[] bytesPosition)
        {
            long number;
            var temp = new byte[8];
            bytesPosition.CopyTo(temp, 0);
            number = BitConverter.ToInt64(temp, 0);
            return number;
        }

        public static int BytesToInteger(byte[] bytesFrameSize)
        {
            var temp = new byte[4];
            bytesFrameSize.CopyTo(temp, 0);
            var number = BitConverter.ToInt32(temp, 0);
            return number;
        }

        #endregion
    }
}